;   This file is a basic code template for object module code         *
;   generation on the PIC16F873A. This file contains the              *
;   basic code building blocks to build upon.  As a project minimum   *
;   the 16F873A.lkr file will also be required for this file to       *
;   correctly build. The .lkr files are located in the MPLAB          *  
;   directory.                                                        *
;                                                                     *
;   If interrupts are not used all code presented between the         *
;   code section "INT_VECTOR and code section "MAIN" can be removed.  *
;   In addition the variable assignments for 'w_temp' and             *
;   'status_temp' can be removed.                                     *                         
;                                                                     *
;   If interrupts are used, as in this template file, the 16F873A.lkr *
;   file will need to be modified as follows: Remove the lines        *
;     CODEPAGE   NAME=vectors  START=0x0      END=0x4      PROTECTED  *
;   and                                                               *
;     SECTION    NAME=STARTUP  ROM=vectors                            *
;   and change the start address of the page0 section from 0x5 to 0x0 *                                                               *
;                                                                     *
;   Refer to the MPASM User's Guide for additional information on     *
;   features of the assembler and linker (Document DS33014).          *
;                                                                     *
;   Refer to the respective PIC data sheet for additional             *
;   information on the instruction set.                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Filename:	    xxx.asm                                           *
;    Date:  21.09.2008                                                *
;    File Version:    12           *
;         
;                       *
;         1- - 8-  .                                                                *
;    Author:                                                          *
;    Company:                                                         *
;                                                                     * 
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required:                                                  *
;                                                                     *
;       64 sym                                                        *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:                                                           *
;                          KS   3CE5                                 *
;                              11.10.2010                             *
;                                                                     *
;                                                                     *
;**********************************************************************


	list		p=16f873a	; list directive to define processor
	#include	<p16f873a.inc>	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _HS_OSC & _WRT_OFF & _LVP_OFF & _CPD_OFF

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The labels following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.
; creating copies of interupt context saving variables in bank1
INT_VAR2        UDATA_SHR       0xFD
WTEMP1           RES     1               ; variable used for context saving 
FTEMP1           RES     1
STEMP1           RES     1               ; variable used for context saving 
; example of using Uninitialized Data Section
TEMP_VAR        UDATA_SHR       0x20            ; explicit address specified is not required
FLAG            RES     1               ;
FLAG1           RES     1               ;
FLAG2           RES     1               ;
;------------------------------------
NHR             RES     1               ;A   1  
NLR             RES     1               ;A  
;-----------------------------------------  
NPR             RES     1               ;-PROGR OTOBR
NP1             RES     1               ; 
R1              RES     1               ;IND
R2              RES     1               ;IND
R3              RES     1               ;IND
R4              RES     1               ;IND
R5              RES     1               ;IND
R6              RES     1               ;IND
R7              RES     1               ;IND
R8              RES     1               ;IND
;-----------------------------------------------------------------
COU             RES     1               ;             2-10 
TEKH            RES     1               ;MEAZ
TEKL            RES     1               ;MEAZ
EDA             RES     1               ;MEAZ
DEA             RES     1               ;MEAZ   
COA             RES     1               ;MEAZ
CCOI            RES     1               ;MEAZ   
DCOI            RES     1               ;MEAZ
COI             RES     1               ;MEAZ
DEI             RES     1               ;MEAZ
EDI             RES     1               ;MEAZ
  
;------------------------------------
SL1             RES     1               ;OPROS
SL2             RES     1               ;
;---------------------------------------
NH              RES     1     
NL              RES     1   
NHM             RES     1   
NLM             RES     1
;--------------------   
RV              RES     1   
;---------------------------------
VDH             RES     1               ;  
VDL             RES     1
;---------------------------------
VDH_S           RES     1               ;MEAZ-V
VDL_S           RES     1               ;MEAZ-V   
;----------------------------------
SVDH            RES     1               ;
SVDL            RES     1               ;
SVDH1           RES     1               ;
SVDL1           RES     1               ;
;---------------------------------
IDH             RES     1               ; 
IDL             RES     1               ;
;---------------------------------
IDH3            RES     1               ;*100
IDL3            RES     1               ;*100
ZAD_R           RES     1               ;
;-------------------------------------
SPWMH           RES     1               ;
SPWML           RES     1               ;
;--------------------------------------
DBC             RES     1               ;
DBB             RES     1               ;
DBA             RES     1               ;

;--------------------------------------
E0H             RES     1               ;
E0              RES     1               ;
E1H             RES     1               ;
E1              RES     1               ;
DIFH            RES     1               ;
DIF             RES     1               ;
PR0H            RES     1               ; 
PR0             RES     1               ;

Rkp             RES     1               ;
Rkd             RES     1               ;
Rki             RES     1               ;
Rko             RES     1               ;
INTH            RES     1               ;
INT             RES     1               ;
PWMH            RES     1               ;
PWM             RES     1               ;
SIST1           RES     1               ;
TEMPA           RES     1               ;+ 2-10
TEMPB           RES     1               ;
TEMPC           RES     1               ;
;---------------------------------
TEMP1           RES     1               ;
SL3             RES     1               ;   - 
SL4             RES     1               ;
SL5             RES     1               ;

;--------------------------------------------
BIT_AVR1        RES     1               ;
BIT_AVR2        RES     1               ;
BIT_AVR3        RES     1               ;
SYM_AVR         RES     1                ;
TEMP_AVR        RES     1                ;
;--------------------------------------------
SIST2           RES     1               ;  1 
T_per			RES     1               ;
TEMP_SV         RES     1                ;
TIP_DV			RES     1               ;
TEMP_RED		RES     1               ;
SIST3			RES     1               ;
SIST4			RES     1               ;
ZAD_RED			RES     1               ;
N_TIPH			RES     1               ;
N_TIPL			RES     1               ;
IDH_TEMP        RES     1              
IDL_TEMP        RES     1              





INT_VAR1        UDATA_SHR        0x7C
PCTEMP          RES     1               ; variable used for context saving   
WTEMP           RES     1               ; variable used for context saving 
FTEMP           RES     1
STEMP           RES     1               ; variable used for context saving
;-------------------------------------
INT_VAR3        UDATA_SHR      0xA0
            

RS1L            RES     1               ;
RS2L            RES     1               ;
RS3L            RES     1               ;
RS4L            RES     1               ;
RS5L            RES     1               ;
RS6L            RES     1               ;
RS7L            RES     1               ;
RS8L            RES     1               ;S
RS9L            RES     1               ;
RS10L           RES     1               ;
RS11L           RES     1               ;
RS12L           RES     1               ;
RS13L           RES     1               ;
RS14L           RES     1               ;
RS15L           RES     1               ;
RS16L           RES     1               ;
RNS_L			RES     1               ;
RNS_H			RES     1               ;
ACCAL0          RES     1      
ACCAH1          RES     1 
ACCBL0          RES     1 
ACCBH1          RES     1 ;   
ACCCL0          RES     1      
ACCCH1          RES     1 
ACCDL0          RES     1 
ACCDH1          RES     1

RNS_VH			RES     1               ;
RNS_VL			RES     1               ;

RS1VH           RES     1
RS1VL           RES     1
RS2VH           RES     1
RS2VL           RES     1
RS3VH           RES     1
RS3VL           RES     1
RS4VH           RES     1
RS4VL           RES     1
RS5VH           RES     1
RS5VL           RES     1
RS6VH           RES     1
RS6VL           RES     1
RS7VH           RES     1
RS7VL           RES     1
RS8VH           RES     1
RS8VL           RES     1
;-----------------------------------------------------------------
;--------------------------------------------------------------------
	
;-------------------------------------------------------------------    

;------------------------------------------------------------------

;#define                Rev             0x7,1   ; 9 .
;#define                In2             0x7,2   ; 8 .2
 
#define         PRZAD25           	FLAG,0  ; 
#define         PRMZ              	FLAG,1  ;
#define         PR_ZAD1          	FLAG,2 
#define         PR_R             	FLAG,3 ;1=,0=
#define         Fraz             	FLAG,4
#define         Favr             	FLAG,5
#define         Frab             	FLAG,6
#define         PR_5             	FLAG,7

#define         PR_COM              FLAG1,0  ; 
#define         PR_NOV              FLAG1,1 ; 
#define         ZNAK           		FLAG1,2 ;0= 
#define         ZNAK2               FLAG1,3 ;   
#define         VKL1                FLAG1,4;     55
#define         PR_DIP1             FLAG1,5; 1
#define         PR_DIP2              FLAG1,6; 2
#define         F_RED               FLAG1,7;    


#define         PR_SL1              FLAG2,0  
#define			PR_1N_DIP           FLAG2,1;
#define         PR_DV1              FLAG2,2;    4.7 
#define         PR_ZAD_R            FLAG2,3;
		

ANVD            EQU     b'10001001'
ANID            EQU     b'10000001'
ANTIP           EQU     b'10011001'
;*****************************************************************
RESET_VECTOR
 		CODE   0x0000           ; processor reset vector
                nop                             ; nop required for icd
         GOTO    INIT            ; go to beginning of program
 ORG 0x004
               MOVWF    WTEMP            ; save off current W register contents
               SWAPF    STATUS ,0         ; move status register into W register
			   CLRF		STATUS
               MOVWF   STEMP  	
			   MOVF		PCLATH,0
               MOVWF   PCTEMP
			   BCF		PCLATH,3
               MOVF    FSR,    0
               MOVWF   FTEMP
               BCF     STATUS,5  
			   GOTO INT10

 ORG    0x15
;------------ interrupt vector location----------------------------
INT10


      
;---------------------------------------------------------------------
               BTFSC   INTCON,1
               GOTO    S1;         INT
               BTFSC   INTCON,2
               GOTO    S2;         TMR0
               BTFSC   PIR1,0
               GOTO    S3;         TMR1
               BTFSC   PIR1,1
               GOTO    S4;         TMR2
;----------------------------------------------------------------------
MS7
			   MOVF	   PCTEMP,0
               MOVWF   PCLATH	
               SWAPF    STEMP,0     ; retrieve copy of STATUS register
               MOVWF   STATUS            ; restore pre-isr STATUS register contents
               MOVF    FTEMP,0
               MOVWF   FSR
               SWAPF    STEMP,0     ; retrieve copy of STATUS register
               MOVWF   STATUS            ; restore pre-isr STATUS register contents
               SWAPF    WTEMP,1          ; restore pre-isr W register contents
               SWAPF    WTEMP,0
               retfie                    ; return from interrupt

 
;-----------------------------------
;-------------------INT---------------------
S1
 
                INCF    NL,1
                BTFSC   STATUS,2
                INCF    NH,1
                BCF     INTCON,1
                 BSF     DBB,7
                 MOVF    DBB,0
                 MOVWF   PORTB
                 BCF     DBB,7
                 MOVF    DBB,0
                 MOVWF   PORTB

                GOTO    MS7
;---------------- 0-------------------
S2
                BCF             INTCON,2
                GOTO    MS7
;-------------- 1-------------------------------------
S3
               MOVLW   0X14                            ;Q=20 MHZ
               MOVWF   TMR1H
               MOVLW   0XF9                            
               MOVWF   TMR1L
               BCF     PIR1,0

               MOVF    ZAD_R,1; ZAD=2 SEK
               BTFSC   STATUS,Z
               GOTO    SZ1
               DECF    ZAD_R,1
               BTFSC   STATUS,Z                
               BCF     PR_ZAD_R

SZ1
;----------------------------------           
               INCF    SIST2,1 ; 
               MOVF    SIST2,0
               SUBLW   .4
               BTFSS   STATUS,2
               GOTO S51
               CLRF    SIST2
               MOVF    NH,0
               MOVWF   NHM
               MOVF    NL,0
               MOVWF   NLM
               CLRF     NH
               CLRF     NL
;----------- ---------------------

          MOVF    TIP_DV,0
          SUBLW   .1
          BTFSC   STATUS,Z    ;
          GOTO    S51
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .2
          BTFSC   STATUS,Z    ;
          GOTO    S51
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .3
          BTFSC   STATUS,Z    ;12   
          GOTO    S51
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .4
          BTFSC   STATUS,Z    ;27 ()
          GOTO    S511
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .5
          BTFSC   STATUS,Z    ;40 (˨)
          GOTO    S511
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .6
          BTFSC   STATUS,Z    ;
          GOTO    S51     
;------------------------------ 
          GOTO    S51     

S511
         BCF     STATUS,C
         RLF     NLM,  1;	
         RLF     NHM,  1

         BCF     STATUS,C
         RLF     NLM,  1;	
         RLF     NHM,  1

S51  
;----------------------------------
     			BTFSC	F_RED
                INCF    SIST4,1
     			BTFSS	F_RED
                CLRF    SIST4
				MOVF	SIST4,0
				ANDLW	B'10000000'
				MOVWF	ZAD_RED
				BTFSS	STATUS,Z
				BCF		F_RED

                INCF    SIST3,1

                INCF    SIST1,1
                MOVF    SIST1,0
                SUBLW   .5
                BTFSS   STATUS,2
                GOTO S31
                CLRF    SIST1

                BTFSC   PR_5
                GOTO    $+3
                BSF     PR_5
                GOTO S31
                BCF     PR_5                               
;----------------------------------        
S31   
               MOVF    TEMP1,1; 
               BTFSC   STATUS,Z
               GOTO    S311
               DECF    TEMP1,1
               BTFSC   STATUS,Z                
               BCF     PR_ZAD1

S311


			MOVLW	.06
			SUBWF	IDH3,0
      		BTFSC	STATUS,C
    	    GOTO	PWM5
;------------------------------------------- 
            movf	IDH3, 0		
    		subwf	SPWMH, 0
    		movwf	TEMP_AVR
       		movf	IDL3, 0		
    		subwf	SPWML, 0
       		btfss	STATUS,C
    		DECF	TEMP_AVR,1

    		BTFSS	TEMP_AVR,7
			GOTO	PWM1;
    	    GOTO	PWM2
;------------------------------------
PWM1
			BCF		STATUS,C
			GOTO	PWM3
PWM2		
			BSF		STATUS,C
PWM3
			RRF		BIT_AVR1,1
			RRF		BIT_AVR2,1
			RRF		BIT_AVR3,1

			CLRF	SYM_AVR
PWM6
			BTFSC	BIT_AVR1,7
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR1,6
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR1,5
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR1,4
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR1,3
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR1,2
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR1,1
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR1,0
			INCF	SYM_AVR,1

			BTFSC	BIT_AVR2,7
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR2,6
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR2,5
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR2,4
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR2,3
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR2,2
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR2,1
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR2,0
			INCF	SYM_AVR,1

			BTFSC	BIT_AVR3,7
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR3,6
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR3,5
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR3,4
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR3,3
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR3,2
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR3,1
			INCF	SYM_AVR,1
			BTFSC	BIT_AVR3,0
			INCF	SYM_AVR,1

            GOTO    MS7			

PWM5
			MOVLW	.35
			MOVWF	SYM_AVR
            GOTO    MS7
;-------------- 2-------------------------------------
S4
          BCF     PIR1,1
          BCF     INTCON,2



		  BTFSC 	PR_SL1
		  GOTO    S71

		  MOVF		SL1,0
		  ADDLW		.155	
		  BTFSC		STATUS,C

	
		  BSF  PR_SL1
		  INCF	 SL1,1
		  GOTO	 S70

S71
		  BCF  PR_SL1
          GOTO        MS7   

S70
		  MOVF	SL1, 0		
		  SUBWF	T_per, 0

          BTFSC   STATUS,Z
          GOTO		YST1

		  MOVF	  SL1,1
          BTFSC   STATUS,2    
          GOTO    S41
          BTFSS   PRMZ
          GOTO    S45
          GOTO    S42
;-----------------------------------------------------
YST1

			MOVLW	.255
			MOVWF	 SL1
         	MOVLW   0X87
       		MOVWF   FSR
       		MOVLW   b'00010100'  
        	MOVWF   INDF  
			CLRF	 VDH_S;
			CLRF	 VDL_S;
     	    GOTO        MS7       
;------------------------------------------------------
S41     
            MOVLW   0X87
            MOVWF   FSR
            MOVLW   b'00010100'  
            MOVWF   INDF    
            BSF     PRMZ
            GOTO        MS7             
S42

;-------------------------------
          MOVF    SL1,0
          SUBLW   .3
          BTFSC   STATUS,2    ;
          GOTO    SVD     
;-------------------------------
          MOVF    SL1,0
          SUBLW   .4
          BTFSC   STATUS,2    ;
          GOTO    SPWM

;----------- ---------------------

          MOVF    TIP_DV,0
          SUBLW   .1
          BTFSC   STATUS,Z    ;
          GOTO    S1001
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .2
          BTFSC   STATUS,Z    ;
          GOTO    S101
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .3
          BTFSC   STATUS,Z    ;
          GOTO    S105
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .4
          BTFSC   STATUS,Z    ;
          GOTO    S102
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .5
          BTFSC   STATUS,Z    ;
          GOTO    S100
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .6
          BTFSC   STATUS,Z    ;
          GOTO    S100     
;------------------------------ 
          GOTO    S100     
S1001

		  BTFSC	  PR_1N_DIP
          GOTO    S100 					

;----------- 1----------------------------- 
          MOVF    SL1,0
          SUBLW   .42
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .43
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .44
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .45
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .46
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .47
          BTFSC   STATUS,2;
          GOTO    VD 
;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .48
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .49
          BTFSC   STATUS,2;
          GOTO    VD 
 ;--------------------------------
 
         MOVF    SL1,0
         SUBLW   .50
         BTFSC   STATUS,2; 40
         GOTO    S46
         GOTO    MS7 
S100
;----------- 1,5,6----------------------------- 
          MOVF    SL1,0
          SUBLW   .22
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .23
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .24
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .25
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .26
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .27
          BTFSC   STATUS,2;
          GOTO    VD 
;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .28
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .29
          BTFSC   STATUS,2;
          GOTO    VD 
 ;--------------------------------
 
         MOVF    SL1,0
         SUBLW   .30
         BTFSC   STATUS,2; 30
         GOTO    S47
         GOTO    MS7 

S101
 
;------- 2------------------------- 
          MOVF    SL1,0
          SUBLW   .20
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .21
          BTFSC   STATUS,2;
          GOTO    VD
;--------------------------------
          MOVF    SL1,0
          SUBLW   .22
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .23
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .24
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .25
          BTFSC   STATUS,2;
          GOTO    VD 
;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .26
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .27
          BTFSC   STATUS,2;
          GOTO    VD  
 ;-------------------------------- 
         MOVF    SL1,0
         SUBLW   .28
         BTFSC   STATUS,2; 13
         GOTO    S47
         GOTO    MS7 
S105
 
;------- 3------------------------- 
          MOVF    SL1,0
          SUBLW   .20
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .21
          BTFSC   STATUS,2;
          GOTO    VD
;--------------------------------
          MOVF    SL1,0
          SUBLW   .22
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .23
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .24
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .25
          BTFSC   STATUS,2;
          GOTO    VD 
;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .26
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .27
          BTFSC   STATUS,2;
          GOTO    VD  
 ;-------------------------------- 
         MOVF    SL1,0
         SUBLW   .28
         BTFSC   STATUS,2;
         GOTO    S46
         GOTO    MS7 
S102
;--------- 4 ----------------------- 
          MOVF    SL1,0
          SUBLW   .61
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
          MOVF    SL1,0
          SUBLW   .62
          BTFSC   STATUS,2;
          GOTO    VD
;--------------------------------
           MOVF    SL1,0
          SUBLW   .63
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
           MOVF    SL1,0
          SUBLW   .64
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
           MOVF    SL1,0
          SUBLW   .65
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
           MOVF    SL1,0
          SUBLW   .66
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
           MOVF    SL1,0
          SUBLW   .67
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
           MOVF    SL1,0
          SUBLW   .68
          BTFSC   STATUS,2;
          GOTO    VD
 ;-------------------------------- 
         MOVF    SL1,0
         SUBLW   .69
         BTFSC   STATUS,2;
         GOTO    S46
         GOTO    MS7 

;----------- -------------- 
S46
		  CALL	SDVIG_V
		  CALL	SUM1
          MOVLW   0X87
          MOVWF   FSR
          MOVLW   b'00010000'  
          MOVWF   INDF  
		  BSF 	 PR_NOV;
          BCF     PRMZ	
          GOTO    MS7       
 ;-------------------------------- 
;-----------2 -------------- 
S47
		  CALL	SDVIG_V
		  CALL	SUM2
          MOVLW   0X87
          MOVWF   FSR
          MOVLW   b'00010000'  
          MOVWF   INDF  
		  BSF 	 PR_NOV;
          BCF     PRMZ	
          GOTO    MS7    

S45

;------------------------ 
        MOVF    SL1,0
        SUBLW   .95     ; 
        BTFSC   STATUS,2
        GOTO    S44
;------------------------
        GOTO    MS7
;------------------------         
S44

         	INCF    SL3,1 ;
        	MOVF    SL3,0
         	SUBLW   .60
        	BTFSS   STATUS,2       
            GOTO    MS7 
			CLRF	SL3

        	CALL    ID
         	GOTO    MS7                                                         
;----------------------------------------------------------             


VD
        MOVLW   ANVD    ; 
        MOVWF   ADCON0
        CALL    ZAD20
        BSF     ADCON0,GO
        NOP
        BTFSC   ADCON0,GO
        GOTO    $-1
		BCF		STATUS,C
        BCF     STATUS,IRP
        MOVLW   0X9E
        MOVWF   FSR
        MOVF    INDF,0
        ADDWF   VDL_S,1
		BTFSC	STATUS,C
		INCF	VDH_S,1
        MOVF    ADRESH, W
        ADDWF   VDH_S,1       
        GOTO    MS7     
  
VD1
        MOVLW   ANVD    ; 
        MOVWF   ADCON0
        CALL    ZAD20
        BSF     ADCON0,GO
        NOP
        BTFSC   ADCON0,GO
        GOTO    $-1
        MOVF    ADRESH, W
        MOVWF   VDH
        BCF     STATUS,IRP
        MOVLW   0X9E
        MOVWF   FSR
        MOVF    INDF,0
        MOVWF   VDL
        RETURN
    

ID
         MOVLW   ANID    ; 
         MOVWF   ADCON0
         CALL    ZAD20
         CALL    ZAD20
         BSF     ADCON0,GO
         NOP
         BTFSC   ADCON0,GO
         GOTO    $-1
         MOVF    ADRESH, W
         MOVWF   IDH
         MOVLW   0X9E
         MOVWF   FSR
         MOVF   INDF,0
         MOVWF   IDL

;------------1----------------
         MOVF    IDH,0
         MOVWF   IDH_TEMP
         MOVF    IDL,0
         MOVWF   IDL_TEMP

;------------2----------------
         MOVF    IDH,0
         ADDWF   IDH_TEMP,1
         MOVF    IDL,0
         ADDWF   IDL_TEMP,1
         BTFSC   STATUS,0
         INCF    IDH_TEMP,1
;------------3----------------
         MOVF    IDH,0
         ADDWF   IDH_TEMP,1
         MOVF    IDL,0
         ADDWF   IDL_TEMP,1
         BTFSC   STATUS,0
         INCF    IDH_TEMP,1
;------------4----------------
         MOVF    IDH,0
         ADDWF   IDH_TEMP,1
         MOVF    IDL,0
         ADDWF   IDL_TEMP,1
         BTFSC   STATUS,0
         INCF    IDH_TEMP,1
;------------5----------------
         MOVF    IDH,0
         ADDWF   IDH_TEMP,1
         MOVF    IDL,0
         ADDWF   IDL_TEMP,1
         BTFSC   STATUS,0
         INCF    IDH_TEMP,1
;------------6----------------
         MOVF    IDH,0
         ADDWF   IDH_TEMP,1
         MOVF    IDL,0
         ADDWF   IDL_TEMP,1
         BTFSC   STATUS,0
         INCF    IDH_TEMP,1
;------------7----------------
         MOVF    IDH,0
         ADDWF   IDH_TEMP,1
         MOVF    IDL,0
         ADDWF   IDL_TEMP,1
         BTFSC   STATUS,0
         INCF    IDH_TEMP,1



		 MOVF	 IDH_TEMP,0		
		 MOVWF	 IDH3
		 MOVF	 IDL_TEMP,0		
		 MOVWF	 IDL3
         RETURN           

;--------SDV-------------
SVD
         MOVF    NHM, W
         MOVWF   SVDH       
         MOVF    NLM, W
         MOVWF   SVDL

          MOVF    TIP_DV,0
          SUBLW   .1
          BTFSC   STATUS,Z    ;
          GOTO    SVD1
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .2
          BTFSC   STATUS,Z    ;
          GOTO    SVD2
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .3
          BTFSC   STATUS,Z    ;
          GOTO    SVD2
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .4
          BTFSC   STATUS,Z    ;
          GOTO    SVD4
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .5
          BTFSC   STATUS,Z    ;4
          GOTO    SVD5
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .6
          BTFSC   STATUS,Z    ;
          GOTO   SVD6     
;------------------------------ 
          GOTO    SVD6 




SVD1
	     NOP	
SVD2
	     NOP	
SVD6
	     NOP	



    	 MOVF	SVDH,1
		 BTFSS	STATUS,Z	
         GOTO    MS7 



		  BTFSC		VKL1 
		  GOTO		SVD11	

		  BCF		STATUS,C
          MOVLW    .195 ;
          ADDWF   SVDL,0
          BTFSC   STATUS,C;  	
		  BSF 	  VKL1;	 60

 		  BTFSS   STATUS,C;  
      	  CLRF	  SVDL
          GOTO    MS7 

SVD11
		  BCF		STATUS,C
          MOVLW    .200  ;
          ADDWF   SVDL,0
          BTFSS   STATUS,C;  
      	  CLRF	  SVDL
          BTFSS   STATUS,C;  	
		  BCF 	  VKL1
          GOTO    MS7 

SVD4

	
        
       	 MOVF	SVDH,1
		 BTFSS	STATUS,Z	
         GOTO    MS7 
 

 

		  BTFSC		VKL1 
		  GOTO		SVD21	

		  BCF		STATUS,C
          MOVLW    .170 ;
          ADDWF   SVDL,0
          BTFSC   STATUS,C;  	
		  BSF 	  VKL1;	 60

 		  BTFSS   STATUS,C;  
      	  CLRF	  SVDL
          GOTO    MS7 

SVD21
		  BCF		STATUS,C
          MOVLW    .175  ;
          ADDWF   SVDL,0
          BTFSS   STATUS,C;  
      	  CLRF	  SVDL
          BTFSS   STATUS,C;  	
		  BCF 	  VKL1
          GOTO    MS7 


	
SVD5
        
      	 MOVF	SVDH,1
		 BTFSS	STATUS,Z	
         GOTO    MS7 
 

 
		  BTFSC		VKL1 
		  GOTO		SVD31	

		  BCF		STATUS,C
          MOVLW    .170 ;
          ADDWF   SVDL,0
          BTFSC   STATUS,C;  	
		  BSF 	  VKL1;	 60

 		  BTFSS   STATUS,C;  
      	  CLRF	  SVDL
          GOTO    MS7 

SVD31
		  BCF		STATUS,C
          MOVLW    .175  ;
          ADDWF   SVDL,0
          BTFSS   STATUS,C;  
      	  CLRF	  SVDL
          BTFSS   STATUS,C;  	
		  BCF 	  VKL1
          GOTO    MS7 
;----------------------------------------------------
SDVIG_V   
        BSF     STATUS,RP0      
 
        MOVF    RS3VH,0          
        MOVWF   RS4VH
        MOVF    RS3VL,0          
        MOVWF   RS4VL

        MOVF    RS2VH,0          
        MOVWF   RS3VH
        MOVF    RS2VL,0          
        MOVWF   RS3VL

        MOVF    RS1VH,0          
        MOVWF   RS2VH         
        MOVF    RS1VL,0          
        MOVWF   RS2VL
        BCF     STATUS,RP0      
        RETURN
;------------1------------------         
SUM1
        BCF STATUS,IRP ;   
        MOVLW   0XBC
        MOVWF   FSR
        MOVF    VDH_S,0    
        MOVWF   INDF
        MOVLW   0XBD
        MOVWF   FSR
        MOVF    VDL_S,0    
        MOVWF   INDF
;--------------------------------- 
        BSF     STATUS,RP0
        CLRF    RNS_VL
        CLRF    RNS_VH
                         
        MOVF    RS1VL,0
        ADDWF   RNS_VL,1
        BTFSC   STATUS,0
        INCF    RNS_VH,1
        MOVF    RS1VH,0
        ADDWF   RNS_VH,1


            BCF  STATUS,C;
			RLF		RNS_VL,1
			RLF		RNS_VH,1

            BCF  STATUS,C;
			RLF		RNS_VL,1
			RLF		RNS_VH,1

            BCF  STATUS,C;
			RLF		RNS_VL,1
			RLF		RNS_VH,1

        BCF     STATUS,RP0
        RETURN
 
 

SUM2
        BCF STATUS,IRP ;  
        MOVLW   0XBC
        MOVWF   FSR
        MOVF    VDH_S,0    
        MOVWF   INDF
        MOVLW   0XBD
        MOVWF   FSR
        MOVF    VDL_S,0    
        MOVWF   INDF
;--------------------------------- 
        BSF     STATUS,RP0
        CLRF    RNS_VL
        CLRF    RNS_VH
                         
        MOVF    RS1VL,0
        ADDWF   RNS_VL,1
        BTFSC   STATUS,0
        INCF    RNS_VH,1
        MOVF    RS1VH,0
        ADDWF   RNS_VH,1

 
        MOVF    RS2VL,0
        ADDWF   RNS_VL,1
        BTFSC   STATUS,0
        INCF    RNS_VH,1
        MOVF    RS2VH,0
        ADDWF   RNS_VH,1


            BCF  STATUS,C;
			RLF		RNS_VL,1
			RLF		RNS_VH,1

            BCF  STATUS,C;
			RLF		RNS_VL,1
			RLF		RNS_VH,1

 
        BCF     STATUS,RP0
         RETURN

SUM3
        BCF STATUS,IRP ;   
        MOVLW   0XBC
        MOVWF   FSR
        MOVF    VDH_S,0    
        MOVWF   INDF
        MOVLW   0XBD
        MOVWF   FSR
        MOVF    VDL_S,0    
        MOVWF   INDF
;--------------------------------- 
        BSF     STATUS,RP0
        CLRF    RNS_VL
        CLRF    RNS_VH
                         
        MOVF    RS1VL,0
        ADDWF   RNS_VL,1
        BTFSC   STATUS,0
        INCF    RNS_VH,1
        MOVF    RS1VH,0
        ADDWF   RNS_VH,1

        MOVF    RS2VL,0
        ADDWF   RNS_VL,1
        BTFSC   STATUS,0
        INCF    RNS_VH,1
        MOVF    RS2VH,0
        ADDWF   RNS_VH,1

        MOVF    RS3VL,0
        ADDWF   RNS_VL,1
        BTFSC   STATUS,0
        INCF    RNS_VH,1
        MOVF    RS3VH,0
        ADDWF   RNS_VH,1

            BCF  STATUS,C;
			RLF		RNS_VL,1
			RLF		RNS_VH,1

            BCF  STATUS,C;
			RLF		RNS_VL,1
			RLF		RNS_VH,1

             
        BCF     STATUS,RP0
         RETURN     

     

SPWM



          MOVF    TIP_DV,0
          SUBLW   .1
          BTFSC   STATUS,Z    ;
          GOTO    SPW1
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .2
          BTFSC   STATUS,Z    ;
          GOTO    SPW2
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .3
          BTFSC   STATUS,Z    ;
          GOTO    SPW3
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .4
          BTFSC   STATUS,Z    ;
          GOTO    SPW4
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .5
          BTFSC   STATUS,Z    ;
          GOTO    SPW5
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .6
          BTFSC   STATUS,Z    ;
          GOTO   SPW6     
;------------------------------ 
          GOTO    SPW6 

SPW1

        
         MOVLW   0X02
         MOVWF   SPWMH
         MOVLW   0X58
         MOVWF   SPWML
         GOTO    MS7
;----------------------------------------- 
SPW2
         MOVLW   0X04
         MOVWF   SPWMH
         MOVLW   0XB0
         MOVWF   SPWML
         GOTO    MS7 
;-------------------------------------------------        
SPW3

         MOVLW   0X04
         MOVWF   SPWMH
         MOVLW   0X4C
         MOVWF   SPWML
         GOTO    MS7         
;-----------------------------------------
SPW4

         MOVLW   0X01
         CLRF   SPWMH
         MOVLW   0XE6
         MOVWF   SPWML
         GOTO    MS7

;---------------------------------------------------
SPW5

         MOVLW   0X02
         MOVWF   SPWMH
         MOVLW   0XBC
         MOVWF   SPWML
         GOTO    MS7
;-----------------------------------------
SPW6
      
         MOVLW   0X03
         MOVWF   SPWMH
         MOVLW   0XE8
         MOVWF   SPWML
         GOTO    MS7
;-----------------------------------------  
ZAD20
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP
ZAD18
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP 
ZAD16
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP
ZAD14
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP    
ZAD12
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP
ZAD10
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP 
ZAD8
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP
ZAD6
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP    
ZAD4
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP
ZAD2
         NOP     
         NOP
         NOP
         NOP 
         NOP
         NOP 
         NOP
         NOP
         NOP
         NOP
         RETURN


 ;------------------------------         
N_TIP
        MOVLW   ANTIP    ; 
        MOVWF   ADCON0
        CALL    ZAD20
        BSF     ADCON0,GO
        NOP
        BTFSC   ADCON0,GO
        GOTO    $-1
        MOVF    ADRESH, W
        MOVWF   N_TIPH
        BCF     STATUS,IRP
        MOVLW   0X9E
        MOVWF   FSR
        MOVF    INDF,0
        MOVWF   N_TIPL
        RETURN
;************************************************************************************************
INIT
             BSF    STATUS,RP0      ; set file register bank to 1 
                     
             movlw       b'10000100'     
             movwf       ADCON1^80H
                    
             movlw       b'00001000'
             movwf       OPTION_REG^80H
                     
             movlw       b'11011011'         
             movwf       TRISA^80H
                    
            movlw       b'00000011'
             movwf       TRISB^80H
                     
             movlw       b'00010000'
             movwf       TRISC^80H
                     
             movlw       b'00000001';----PERIPHERAL------TMR1
             movwf       PIE1^80H
                                             
             movlw        b'00000000'
             movwf        PIE2^80H
                                     
             movlw       b'11111111';
             movwf       PR2^80H
                     
             movlw   b'01000000'
             movwf   SSPSTAT^80H;    SPI
                     
             BCF    STATUS,RP0        ; set file register bank to 0
    
             movlw   b'10000001'     
             movwf   ADCON0
                     
             movlw   b'11010000'
             movwf   INTCON                  ;!!!!!INT!!!!!!!!!!!!!
     
             movlw   b'00110001'
             movwf   T1CON
             
    	     movlw   b'00000100'
             movwf   T2CON
    
             movlw   b'00100001'
             movwf   SSPCON      ;SPI


                 CLRF    FLAG
                 CLRF    FLAG1
                 CLRF    FLAG2


                 MOVLW   B'00000010'
                 MOVWF    DBC
                 MOVWF   PORTC
          
                 MOVLW   B'00000000'
                 MOVWF    DBB
                 MOVWF   PORTB
 			   	 CLRF	PCLATH
				 CLRF	BIT_AVR1        
				 CLRF	BIT_AVR2        
				 CLRF	BIT_AVR3        
				 CLRF	SYM_AVR                                   
                 BCF     Favr 
                 BCF     Frab                  
                 BSF     Fraz;  
   	        	 BCF     DBA,5
 	        	 BSF     DBA,4
  	        	 BCF     DBA,2
           		 MOVF    DBA,0
                 MOVWF   PORTA  

   	            CLRF    NLM
        	    CLRF   NHM
              	CLRF     NH
               	CLRF     NL


 ;---------------------------------
MZ1
                 MOVLW   0X05;   ZAD=1 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
				 NOP
                 BTFSC   PR_ZAD1
                 GOTO    $-2
                 CALL    N_TIP 
            	 MOVF	N_TIPH, 0		
            	 MOVWF	TEMPA
            	 MOVF	N_TIPL, 0		
            	 MOVWF	TEMPB

                
                 MOVLW   0X05;   ZAD=0.5 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
				 NOP
                 BTFSC   PR_ZAD1
                 GOTO    $-2
                 CALL    N_TIP 
    
            	 MOVF	N_TIPH, 0		
            	 SUBWF	TEMPA, 0
            		
                 BTFSS   STATUS,Z
                 GOTO    MZ1

                 MOVF  N_TIPL, 0
            	 SUBWF	TEMPB, 0
                 BTFSS  STATUS,Z
                 GOTO    MZ1
    


;------------------0-------920---------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X03
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0X98
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T0
;------------------1-------820---------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X03
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0X34
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T1
;------------------2-----745-----------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X02
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0XE9
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T2
;------------------3-------650---------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X02
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0X8A
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T3
;------------------4----------------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X01
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0XFF
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T4
;------------------5----------------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X01
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0X77
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T5
;------------------6----------------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X00
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0XF0
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T6
;------------------7----------------
				 MOVF	N_TIPH,0; 		
				 SUBLW	0X00
				 MOVWF	TEMPA
		
				 MOVF	N_TIPL,0	;	
				 SUBLW	0X50
				 MOVWF	TEMPB
		
				 BTFSS	STATUS,C
				 DECF	TEMPA,1
				 BTFSC	TEMPA,7
				 GOTO   M_T7
				 GOTO   M_T8
 
M_T0			 MOVLW	.0
				 MOVWF	 TIP_DV		
	    		 GOTO	MZ1
M_T1
				BSF	PCLATH,3 
				CALL	DLDV1
				BCF	PCLATH,3 
			 	GOTO	 MZ2
M_T2
				BSF	PCLATH,3 
				CALL	DLDV2
				BCF	PCLATH,3 
			 	GOTO	 MZ2
M_T3
				BSF	PCLATH,3 
				CALL	DLDV3
				BCF	PCLATH,3 
			 	GOTO	 MZ2
M_T4
				BSF	PCLATH,3 
				CALL	DLDV4
				BCF	PCLATH,3 
			 	GOTO	 MZ2
M_T5
				BSF	PCLATH,3 
				CALL	DLDV5
				BCF	PCLATH,3 
			 	GOTO	 MZ2
M_T6
				BSF	PCLATH,3 
				CALL	DLDV6
				BCF	PCLATH,3 
			 	GOTO	 MZ2
M_T7
				BSF	PCLATH,3 
				CALL	DLDV6
				BCF	PCLATH,3 
			 	GOTO	 MZ2
M_T8
				BSF	PCLATH,3 
				CALL	DLDV6
				BCF	PCLATH,3 
			 	GOTO	 MZ2

MZ2

                 MOVLW   B'00000000'
                 MOVWF    DBB
                 MOVWF   PORTB

                 MOVLW   0X05;   ZAD=0.5 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
				 MOVF	 TIP_DV,0
				 MOVWF	 TEMPA	 
MZ3
                 MOVLW   B'00000100'
                 MOVWF    DBB
                 MOVWF   PORTB

                 MOVLW   0X05;   ZAD=0.5 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
MZ4
                 BTFSC   PR_ZAD1
                 GOTO    MZ4
 
                 MOVLW   B'00000000'
                 MOVWF    DBB
                 MOVWF   PORTB

                 MOVLW   0X05;   ZAD=0.5 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
MZ5
                 BTFSC   PR_ZAD1
                 GOTO    MZ5

				 DECFSZ		TEMPA,1
                 GOTO    MZ3

                 MOVLW   B'00000000'
                 MOVWF    DBB
                 MOVWF   PORTB

                 MOVLW   0X014;   ZAD=2 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
MZ7
                 BTFSC   PR_ZAD1
                 GOTO    MZ7
;-----------------------------------------------------------
		
 ; -----     0   1----------------           
                BCF STATUS,IRP
                MOVLW   0X8C
                MOVWF   FSR
                MOVLW    b'00000011';----PERIPHERAL------TMR2,TMR1
                MOVWF   INDF             ;PIE1^80H
                CLRF    SIST1
                CLRF    SIST2
;---------------------------------------------------
				 BSF	PCLATH,3                  
                 CALL    DT11 ;   
   	        	 BCF     DBA,5
  	        	 BCF     DBA,2
  	        	 BSF     DBA,4
           		 MOVF    DBA,0
                 MOVWF   PORTA     
;**********************************************************************************
              	CLRF     SVDH
               	CLRF     SVDL
  	            CLRF     NLM
        	    CLRF     NHM
              	CLRF     NH
               	CLRF     NL
				 CLRF	BIT_AVR1        
				 CLRF	BIT_AVR2        
				 CLRF	BIT_AVR3        
				 CLRF	SYM_AVR
                 BCF     Favr 
                CLRF	IDH3	
       		    CLRF	IDL3	
;**********************************************************************************
M1
				 BSF	PCLATH,3 
                 CLRWDT
                 CALL    ANALIZ_R
                 CALL    ANALIZ_S
                 CALL    DATA_SHIM
                 CALL    SHIM            
         		 CALL    VIVOD
        		 CALL    REGIM
         		 CALL    IND
          		 CALL    PORT
				 CALL    PWA;  
				 BCF	PCLATH,3
                 CALL    N_TIP 	        		 
                 GOTO M1
;***********************************************************************************

     ORG 0X800


;***********************************************************************************

ANALIZ_S
            	movf	SVDH, 1
	        	BTFSS	STATUS,Z
            	RETURN	        	     			 
            	movf	SVDL, 0		; 
 	        	SUBLW	.40 ;400 /    	    
	        	BTFSS	STATUS,C
            	RETURN
;-------------------------------
                BSF     Fraz;  
            	RETURN                
DT11
            CLRF	PWMH
        	CLRF	PWM

            CLRF	PR0H
        	CLRF	PR0

        	CLRF    INTH
        	CLRF    INT;  
			CLRF	BIT_AVR1        
			CLRF	BIT_AVR2        
			CLRF	BIT_AVR3        
			CLRF	SYM_AVR 
			CLRF	TEMPA; 
			CLRF	TEMPB
			CLRF	TEMPC
        	CLRF    E0
            CLRF    E1
            CLRF    E0H
            CLRF    E1H
             CLRF    NLR 
            CLRF    NHR 
 			BCF		F_RED

           	RETURN    	
;***********************************************************************************
PWA
			MOVF	SYM_AVR,0
			ADDLW	.235			
			BTFSS	STATUS,C
            RETURN		


			BSF     Favr;
            MOVLW   0X05;   ZAD=0.5 SEK
            MOVWF   TEMP1;
            BSF     PR_ZAD1
            BSF     DBA,5
            MOVF    DBA,0
            MOVWF   PORTA
PWM110

            CLRF	PWMH
        	CLRF	PWM			
			CALL	SHIM	
			CALL	DT11	
            BTFSC   PR_ZAD1
            GOTO    PWM110
   	        BCF     DBA,5
            MOVF    DBA,0
            MOVWF   PORTA
            RETURN

;*****************************************

DLDV1

             MOVLW   .3
             MOVWF   Rkd
             MOVLW   .4
             MOVWF   Rkp
             MOVLW   .3
             MOVWF   Rki
             MOVLW   .3
             MOVWF   Rko
             MOVLW   .200
             MOVWF   T_per
             MOVLW   .1
             MOVWF   TIP_DV
             BSF     PR_DV1;

   		     BSF    STATUS,RP0      ; set file register bank to 1 
             movlw       b'11011011'         
             movwf       TRISA^80H
             BCF    STATUS,RP0        ; set file register bank to 0
   
             RETURN
;----------------2.2 k-----2-12 ---------------------------
DLDV2
             MOVLW   .3
             MOVWF   Rkd
             MOVLW   .4
             MOVWF   Rkp
             MOVLW   .3
             MOVWF   Rki
             MOVLW   .3
             MOVWF   Rko
             MOVLW   .200
             MOVWF   T_per
             MOVLW   .2
             MOVWF   TIP_DV
             BCF     PR_DV1;

   		     BSF    STATUS,RP0      ; set file register bank to 1 
             movlw       b'11011011'         
             movwf       TRISA^80H
             BCF    STATUS,RP0        ; set file register bank to 0
    
             RETURN
;------------------2,2 k---3-12 ------------------
DLDV3

             MOVLW   .4
             MOVWF   Rkd
             MOVLW   .5
             MOVWF   Rkp
             MOVLW   .3
             MOVWF   Rki
             MOVLW   .3
             MOVWF   Rko
             MOVLW   .200
             MOVWF   T_per
             MOVLW   .3
             MOVWF   TIP_DV
   		     BSF    STATUS,RP0      ; set file register bank to 1 
             movlw       b'11011011'         
             movwf       TRISA^80H
             BCF    STATUS,RP0        ; set file register bank to 0

             RETURN
;----------------4,7 k-----4----------------------------
DLDV4
             MOVLW   .3
             MOVWF   Rkd
             MOVLW   .4
             MOVWF   Rkp
             MOVLW   .3
             MOVWF   Rki
             MOVLW   .3
             MOVWF   Rko
             MOVLW   .255
             MOVWF   T_per
             MOVLW   .4
             MOVWF   TIP_DV


   		     BSF    STATUS,RP0      ; set file register bank to 1 
             movlw       b'11011111'         
             movwf       TRISA^80H
             BCF    STATUS,RP0        ; set file register bank to 0


             RETURN

DLDV5

             MOVLW   .3
             MOVWF   Rkd
             MOVLW   .4
             MOVWF   Rkp
             MOVLW   .3
             MOVWF   Rki
             MOVLW   .3
             MOVWF   Rko
             MOVLW   .200
             MOVWF   T_per
             MOVLW   .5
             MOVWF   TIP_DV


   		     BSF    STATUS,RP0      ; set file register bank to 1 
             movlw       b'11011111'         
             movwf       TRISA^80H
             BCF    STATUS,RP0        ; set file register bank to 0


             RETURN
;----------------4,7 k-----6---------------------------
DLDV6
             MOVLW   .3
             MOVWF   Rkd
             MOVLW   .5
             MOVWF   Rkp
             MOVLW   .3
             MOVWF   Rki
             MOVLW   .3
             MOVWF   Rko
             MOVLW   .255
             MOVWF   T_per
             MOVLW   .6
             MOVWF   TIP_DV

   		     BSF    STATUS,RP0      ; set file register bank to 1 
             movlw       b'11011011'         
             movwf       TRISA^80H
             BCF    STATUS,RP0        ; set file register bank to 0

             RETURN

;*****************************************************		
DATA_SHIM;  0.5 /

;-----------------------------------------------------
            BTFSS   Frab
            CALL    DT11
            BTFSS   Frab
            RETURN            
 ;-----------------------------------------------------
            BTFSC   Favr
            CALL    DT11
           	BTFSC   Favr
            RETURN
;-----------------------------------------------------
            BTFSC   F_RED
            GOTO	DATA_RED  
;------------------------------------------------------
			MOVF	SVDH,0
			ADDWF	SVDL,0
            BTFSC   STATUS,Z;  0   
            CALL    DT11
;-----------------------------------------------------
VR
        	BTFSS   PR_NOV       
        	RETURN
        	BCF   	PR_NOV
;---------------------------------------------------------
            BTFSC   PR_ZAD_R
        	RETURN
                     

  
	        BCF STATUS,IRP
    	    MOVLW   0XBA
     	    MOVWF   FSR
     	    MOVF   INDF,0
     	    MOVWF    R1
        
    	    MOVLW   0XBB
     	    MOVWF   FSR
     	    MOVF   INDF,0
     	    MOVWF    R2


          MOVF    TIP_DV,0
          SUBLW   .1
          BTFSC   STATUS,Z    ;
          GOTO    VR1
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .2
          BTFSC   STATUS,Z    ;
          GOTO    VR2
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .3
          BTFSC   STATUS,Z    ;
          GOTO    VR3
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .4
          BTFSC   STATUS,Z    ;
          GOTO    VR4
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .5
          BTFSC   STATUS,Z    ;
          GOTO    VR5
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .6
          BTFSC   STATUS,Z    ;
          GOTO    VR6     
;------------------------------ 
          GOTO    VR6 

VR1

			MOVLW	.148;119
			MOVWF	R6;CONST_DV
			CALL	DIV1

      		MOVF    R3,W ;ACCBH1
        	MOVWF   VDH
       		MOVF    R4,W;ACCBL0
       		MOVWF   VDL

            GOTO    VR20
 ;-------------------------------- 
VR2

			MOVLW	.100;96
			MOVWF	R6;CONST_DV
			CALL	DIV1

      		MOVF    R3,W ;ACCBH1
        	MOVWF   VDH
       		MOVF    R4,W;ACCBL0
       		MOVWF   VDL

            GOTO    VR20
 ;--------------------------------
VR3

			MOVLW	.55
			MOVWF	R6;CONST_DV
			CALL	DIV1

      		MOVF    R3,W ;ACCBH1
        	MOVWF   VDH
       		MOVF    R4,W;ACCBL0
       		MOVWF   VDL

            GOTO    VR20
 ;--------------------------------  
VR4

			MOVLW	.77
			MOVWF	R6;CONST_DV
			CALL	DIV1

      		MOVF    R3,W ;ACCBH1
        	MOVWF   VDH
       		MOVF    R4,W;ACCBL0
       		MOVWF   VDL

            GOTO    VR20
 ;-------------------------------- 
VR5

			MOVLW	.76
			MOVWF	R6;CONST_DV
			CALL	DIV1

      		MOVF    R3,W ;ACCBH1
        	MOVWF   VDH
       		MOVF    R4,W;ACCBL0
       		MOVWF   VDL

            GOTO    VR20
 ;--------------------------------
VR6

			MOVLW	.60;
			MOVWF	R6;CONST_DV
			CALL	DIV1

      		MOVF    R3,W ;ACCBH1
        	MOVWF   VDH
       		MOVF    R4,W;ACCBL0
       		MOVWF   VDL

            GOTO    VR20
 ;--------------------------------  
;---------------------------------------------------------
VR20
;---------------------------------------------------------	
       	   	CALL    Ferr
	      	CALL    Ppp  		
       		CALL    DifCom 
       		CALL    IntCom
       		CALL    Total
       		CALL    Ovrld
        	RETURN
;-----------------------------------------
DATA_RED
			CLRF	PWMH
			MOVLW	.20
			MOVWF	PWM
			RETURN
;-----------------------------------------


Ferr

				 MOVF	SVDH1, 0;		
				 SUBWF	SVDH, 0
				 MOVWF	R1
		
				 MOVF	SVDL1, 0	;	
				 SUBWF	SVDL, 0
				 MOVWF	R2
				 BTFSS	STATUS,C
				 DECF	R1,1


		
		         BTFSC   R1,7;
				 GOTO	Ferr01    ;   
				 GOTO	COR2    ;   

COR2
				MOVF	R1,1
				BNZ		COR_POZ
				MOVLW	.230   ;26
				ADDWF	R2,0
       		    BTFSC   STATUS,C
				GOTO	COR_POZ;   
				GOTO     Ferr01

;---------------------------------------------------

COR_POZ
		        BSF	Fraz
				GOTO Ferr01
;-----------------------------------------------------
Ferr01
				 MOVF	VDH, 0;		
				 SUBWF	SVDH, 0
				 MOVWF	E0H
				 MOVF	VDL, 0	;	
				 SUBWF	SVDL, 0
				 MOVWF	E0
				 BTFSS	STATUS,C
				 DECF	E0H,1

		         BTFSS   E0H,7
				 GOTO	FER1
		         BCF	Fraz

FER4
				 MOVLW	0XFF;		
				 SUBWF	E0H, 0
				 MOVWF	R1
		
				 MOVLW	0XE0	;	
				 SUBWF	E0, 0
				 BTFSS	STATUS,C
				 DECF	R1,1
		
		         BTFSS  R1,7;
				 RETURN
;--------------------------------------
				 MOVLW	0XFF
				 MOVWF	E0H
				 MOVLW	0XE0
				 MOVWF	E0
				 RETURN
;---------------------------------------------------

FER1
		         BTFSC   E0H,6
				 GOTO	 FER4
	             BTFSC   Fraz;
		         GOTO     FER2
;----------------------------------

				 MOVF	E0H,1
				 BTFSS	STATUS,Z
		         GOTO     FER3

				 MOVF	E0,0
				 SUBLW	.30
				 MOVWF	R1
		         BTFSS  R1,7
				 RETURN
;--------------------------------------
FER3
				 CLRF	E0H
				 MOVLW	.30
				 MOVWF	E0
				 RETURN
;-----------------------------------------
FER2
	        	 MOVLW	.2
	        	 movwf	E0
	        	 CLRF    E0H


 		         MOVF    TIP_DV,0
		         SUBLW   .4
          		 BTFSS   STATUS,Z    ;27 ()
				 RETURN


;			     BTFSC		PR_DIP1
;	        	 RETURN

	        	 MOVLW	.20
	        	 movwf	E0
	        	 RETURN
;-----------------------------------------------------
Ppp	
;----------------------------------------------------
				MOVF	SVDH,0
				MOVWF	SVDH1
				MOVF	SVDL,0
				MOVWF	SVDL1
;----------------------------------------------------


						; 
			MOVF	E0, W	; 
			MOVWF	PR0		
			MOVF	E0H, W
			MOVWF	PR0H

			MOVF	Rkp ,W
			MOVWF	TEMPA

			BCF		STATUS,C
			RLF		PR0, F
			RLF		PR0H, F
			DECFSZ	TEMPA,1
			GOTO	$-4
			RETURN

;------------------------------------------------------

DifCom						; 
			MOVF	E1H, W	; 
			SUBWF	E0H, W		
			MOVWF	DIFH
			MOVF	E1, W
			SUBWF	E0, W
			MOVWF	DIF
			BTFSS	STATUS,C
			DECF	DIFH, F

			MOVF	Rkd ,W
			MOVWF	TEMPA

			BCF		STATUS,C
			RLF		DIF, F
			RLF		DIFH, F
			DECFSZ	TEMPA,1
			GOTO	$-4

			MOVF	E0H, 0
			MOVWF	E1H
			MOVF	E0, 0
			MOVWF	E1
			RETURN

;------------------------------------------------------

IntCom				
			MOVF	E0H, W		
			MOVWF	TEMPB	;
			MOVF	E0, W
			MOVWF	TEMPA

			MOVF	Rki ,W
			MOVWF	TEMPC		;

			MOVF	TEMPC, F	; 
			BTFSC	STATUS,Z	
			GOTO	int1		; 

			BCF		STATUS,C
			RLF		TEMPA, F
			RLF		TEMPB, F
			DECFSZ	TEMPC,1
			GOTO	$-4
int1
			MOVF	TEMPA, W
			ADDWF	INT, F
			BTFSC	STATUS,C
			INCF	INTH, F

			MOVF	TEMPB, W
			ADDWF	INTH, F
			RETURN

;-------------------------------------------------------
Total	
PCOM
			MOVF	PR0H, W		; 
			MOVWF	PWMH
			MOVF	PR0, W	
			MOVWF	PWM

ICOM
			MOVF	INTH, W		; 
			ADDWF	PWMH, F
			MOVF	INT, W	
			ADDWF	PWM, F
			BTFSC	STATUS,C
			INCF	PWMH, F
DCOM
			MOVF	DIFH, W		; 
			ADDWF	PWMH, F
			MOVF	DIF, W	
			ADDWF	PWM, F
			BTFSC	STATUS,C
			INCF	PWMH, F
;-------------------------------------
			MOVF	PWMH,0	
			ADDLW	0X40; 
			BTFSC	STATUS,C
			GOTO	NegPwm	
			MOVF	PWMH,0	
			ADDLW	0X82
			BTFSS	STATUS,C
			RETURN
			MOVLW	0X7F
			MOVWF	PWMH
			MOVWF	INTH
			MOVLW	0XFF
			MOVWF	PWM
			MOVWF	INT
			RETURN
NegPwm
			CLRF	PWMH
			CLRF	PWM
			CLRF    INTH
			CLRF    INT
			RETURN
;-------------------------------------------------------
Ovrld
;--------------------------------

          MOVF    TIP_DV,0
          SUBLW   .1
          BTFSC   STATUS,Z    ;
          GOTO    OVR1
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .2
          BTFSC   STATUS,Z    ;
          GOTO    OVR2
;-----------------------------     
          MOVF    TIP_DV,0
          SUBLW   .3
          BTFSC   STATUS,Z    ;
          GOTO    OVR3
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .4
          BTFSC   STATUS,Z    ;
          GOTO    OVR4
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .5
          BTFSC   STATUS,Z    ;
          GOTO    OVR5
;------------------------------     
          MOVF    TIP_DV,0
          SUBLW   .6
          BTFSC   STATUS,Z    ;
          GOTO    OVR6     
;------------------------------ 
          GOTO    OVR6 
;----------1---------------------------
OVR1
		MOVF	SVDH,1
		BTFSS	STATUS,Z
		GOTO	PW_R

		BTFSC	PR_DIP1	 	
		GOTO	PW2

		MOVLW	.135 ;
		ADDWF	SVDL,0
    	BTFSC   STATUS,C;
		GOTO	PW1

		MOVLW	.4	
		MOVWF	Rko
 		MOVLW	.150
		MOVWF	T_per
		BCF		PR_1N_DIP; 
		GOTO	PW_R
;-------- 110--------------------
PW2
		MOVLW	.145 ;110	
		ADDWF	SVDL,0
   		BTFSS   STATUS,C;
		BCF		PR_DIP1
 		GOTO  PW_R
;-------- 120--------------------
PW1
	
		MOVLW	.3	
		MOVWF	Rko
 		MOVLW	.250
		MOVWF	T_per
		BSF		PR_DIP1
		BSF		PR_1N_DIP; 
		GOTO	PW_R
;-------------------------------------
;----------2---------------------------
OVR2
		MOVF	SVDH,1
		BTFSS	STATUS,Z
		GOTO	PW_R

		BTFSC	PR_DIP1	 	
		GOTO	PW22

		MOVLW	.150 ;105 	
		ADDWF	SVDL,0
    	BTFSC   STATUS,C;
		GOTO	PW12

		MOVLW	.4	
		MOVWF	Rko
 		MOVLW	.150
		MOVWF	T_per
		GOTO	PW_R
;-------- 110--------------------
PW22
		MOVLW	.160 ;95	
		ADDWF	SVDL,0
   		BTFSS   STATUS,C;
		BCF		PR_DIP1
 		GOTO  PW_R
;-------- 120--------------------
PW12
	
		MOVLW	.3	
		MOVWF	Rko
 		MOVLW	.190
		MOVWF	T_per
		BSF		PR_DIP1
		GOTO	PW_R
;-------------------------------------
;----------3---------------------------
OVR3
		MOVF	SVDH,1
		BTFSS	STATUS,Z
		GOTO	PW_R

		BTFSC	PR_DIP1	 	
		GOTO	PWD22

		MOVLW	.150 ;105 	
		ADDWF	SVDL,0
    	BTFSC   STATUS,C;
		GOTO	PWD12

		MOVLW	.4	
		MOVWF	Rko
 		MOVLW	.150
		MOVWF	T_per
		GOTO	PW_R
;-------- 110--------------------
PWD22
		MOVLW	.160 ;95	
		ADDWF	SVDL,0
   		BTFSS   STATUS,C;
		BCF		PR_DIP1
 		GOTO  PW_R
;-------- 120--------------------
PWD12
	
		MOVLW	.3	
		MOVWF	Rko
 		MOVLW	.190
		MOVWF	T_per
		BSF		PR_DIP1
		GOTO	PW_R
;-------------------------------------
;----------4---------------------------

OVR4
		MOVF	SVDH,1
		BTFSS	STATUS,Z
		GOTO	PW13

		BTFSC	PR_DIP1; 	 	
		GOTO	PW23

		MOVLW	.1;255 
		ADDWF	SVDL,0
    	BTFSC   STATUS,C;
		GOTO	PW13


		MOVLW	.5	
		MOVWF	Rko
 		MOVLW	.200
		MOVWF	T_per


		BTFSC	PR_DIP2	 	
		GOTO	PW241

		MOVLW	.50;-205 ;
		ADDWF	SVDL,0
   		BTFSS   STATUS,C;  	
		GOTO	PW132
	
 		GOTO	PW_R	

PW23
		MOVLW	.25 ;235;	
		ADDWF	SVDL,0
   		BTFSS   STATUS,C;
		BCF		PR_DIP1
 		GOTO  PW_R

PW13
	
		MOVLW	.4	
		MOVWF	Rko
 		MOVLW	.250
		MOVWF	T_per
		BSF		PR_DIP1
		BCF		PR_DIP2
		GOTO	PW_R

PW132
		MOVLW	.6	
		MOVWF	Rko
 		MOVLW	.200
		MOVWF	T_per
		BSF		PR_DIP2
		BCF		PR_DIP1
		GOTO	PW_R

PW241
		MOVLW	.30	
		ADDWF	SVDL,0; 
   		BTFSC   STATUS,C;
		BCF		PR_DIP2
		BCF		PR_DIP1

		MOVLW	.6	
		MOVWF	Rko
 		MOVLW	.200
		MOVWF	T_per

		GOTO	PW_R

OVR5

		MOVF	SVDH,1
		BTFSS	STATUS,Z
		GOTO	PW_R

		BTFSC	PR_DIP1	 	
		GOTO	PW24

		MOVLW	.50 ;205 	
		ADDWF	SVDL,0
    	BTFSC   STATUS,C;
		GOTO	PW14

		MOVLW	.4	
		MOVWF	Rko
 		MOVLW	.150
		MOVWF	T_per
		GOTO	PW_R
;-------- 195--------------------
PW24
		MOVLW	.60 ;195  	
		ADDWF	SVDL,0
   		BTFSS   STATUS,C;
		BCF		PR_DIP1
 		GOTO  PW_R
;-------- 200--------------------
PW14
	
		MOVLW	.3	
		MOVWF	Rko
 		MOVLW	.250
		MOVWF	T_per
		BSF		PR_DIP1
		GOTO	PW_R
;-------------------------------------
;----------6---------------------------
OVR6

		MOVF	SVDH,1
		BTFSS	STATUS,Z
		GOTO	PW_R

		BTFSC	PR_DIP1	 	
		GOTO	PW25

		MOVLW	.150 ; 	
		ADDWF	SVDL,0
    	BTFSC   STATUS,C;
		GOTO	PW15

		MOVLW	.4	
		MOVWF	Rko
 		MOVLW	.200
		MOVWF	T_per
		GOTO	PW_R

PW25
		MOVLW	.160 ;	
		ADDWF	SVDL,0
   		BTFSS   STATUS,C;
		BCF		PR_DIP1
 		GOTO  PW_R

PW15
	
		MOVLW	.4	
		MOVWF	Rko
 		MOVLW	.250
		MOVWF	T_per
		BSF		PR_DIP1
		GOTO	PW_R

PW_R

    	movf	Rko ,0
		movwf	TEMPA		; PWM:Ko
		bcf		STATUS,C
		rrf		PWMH, F
		rrf		PWM, F
		decfsz	TEMPA,1
		goto	$-4
		RETURN
		MOVLW	.35
		MOVWF	PWM
		clrf	PWMH
		RETURN
;-----------------------------------------------

    		
ANALIZ_R 
		         BTFSC     F_RED;
 		 		 RETURN 

        BTFSC Favr                
        RETURN

              		
		movf	SVDH, 1
		BTFSS	STATUS,Z
		GOTO	ANZ112		        
		movf	SVDL, 0		
		SUBLW	.10
		BTFSC	STATUS,C
	    GOTO    ANZ11
ANZ112
	    BSF     Frab
        RETURN			
ANZ11
        
	    BCF   Frab  
		BCF   Favr 
		BSF   Fraz
		CLRF	BIT_AVR1        
		CLRF	BIT_AVR2        
		CLRF	BIT_AVR3        
		CLRF	SYM_AVR
		CLRF	VDH 
		CLRF	VDL 
		MOVLW	.10
		MOVWF	ZAD_R
		BSF		PR_ZAD_R
        RETURN


   	

DIV1             

         

         MOVF   	R1,0;ACCCH1
         MOVWF   	R3;ACCBH1
         MOVF   	R2,0;ACCCL0
         MOVWF   	R4;ACCBL0
         CLRF   	R5;ACCAH1
;*******************************************************************
;       Double Precision Divide ( 16/16 -> 16 )
;        ( ACCb/ACCa -> ACCb with remainder in ACCc ) : 16 bit output
; with Quotiont in ACCb (ACCbHI,ACCbLO) and Remainder in ACCc (ACCcHI,ACCcLO).
;*******************************************************************
 
;
D_divF1
         CALL    setup2
         CLRF    R1;ACCCH1
         CLRF    R2;ACCCL0

; use the mulMac macro 16 times
;
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1
        CALL     divMac1

        RETURN
;*******************************************************************
    
 
divMac1  

        BCF     STATUS,C
        RLF     R8, 1 ;ACCDL0
        RLF     R7, 1 ;ACCDH1
        RLF     R2, 1 ;ACCCL0
        RLF     R1, 1 ;ACCCH1
        MOVF    R5, W ;ACCAH1
        SUBWF    R1, W ;ACCCH1        ;check if a>c
        BTFSS   STATUS,Z
        GOTO    NOCHK1
        MOVF    R6, W ;ACCAL0
        SUBWF   R2, W ;ACCCL0        ;if msb equal then check lsb
NOCHK1
        BTFSS    STATUS,C        ;carry set if c>a
        GOTO     NOGO1
        MOVF     R6, W ;ACCAL0        ;c-a into c
        SUBWF     R2, 1 ;ACCCL0
        BTFSS    STATUS,C
        DECF     R1, 1 ;ACCCH1
        MOVF     R5, W ;ACCAH1
        SUBWF     R1, 1 ;ACCCH1
        BSF      STATUS,C        ;shift a 1 into b (result)
NOGO1
        RLF      R4, 1 ;ACCBL0
        RLF      R3, 1 ;ACCBH1
        RETURN
;-----------------------------------------------------------------      
setup2
        MOVF    R3,W ;ACCBH1         ;move ACCb to ACCd
        MOVWF   R7;ACCDH1
        MOVF     R4,W;ACCBL0
        MOVWF   R8;ACCDL0
        CLRF    R3;ACCBH1
        CLRF    R4;ACCBL0
        RETLW   0    
    	
    	
 
;---------------------------------------
PORT

			BTFSC	Frab
			GOTO	POR1
			GOTO	POR2

POR1

			MOVF	VDH,1
			BTFSS   STATUS,Z
			GOTO	POR21

			ADDWF	VDL,0
			BTFSC   STATUS,Z
			GOTO	POR2
POR21
            BSF     DBC,7;      ;
			GOTO	POR3
POR2
            BCF     DBC,7;      ;
			GOTO	POR3
POR3
            MOVF    DBC,0
            MOVWF   PORTC

            BTFSC     F_RED
 			RETURN

  
;
			MOVF	VDH,1
			BTFSS	STATUS,Z
			RETURN

			MOVF	VDL,0;
			ADDLW	.245
			BTFSC	STATUS,C
			RETURN
;-------------------------------------------------------------

            BCF     DBB,5
            BTFSS   PORTB,1
            BSF     DBB,5
            MOVF    DBB,0
            MOVWF   PORTB
            RETURN
;--------------------------       
REGIM

                 BTFSS PORTA,4;              
                 GOTO   REG4

                 BTFSC Favr                
                 GOTO   REG5
               
                 MOVF    SVDH,1
                 BTFSS   STATUS,2
                 GOTO    REG1
                 MOVF    SVDL,1
                 BTFSS   STATUS,2
                 GOTO    REG1
                 
                 BTFSS     PR_5 
                 GOTO      REG3 
                 
          
REG1
                 BSF     DBB,2
                 BCF     DBB,3;
                 MOVF    DBB,0
                 MOVWF   PORTB
                 GOTO    REG1_3                 

REG4               
                 BCF    Favr
   	             CLRF    NLM
        	     CLRF    NHM
              	 CLRF     NH
               	 CLRF     NL
				 BSF    Fraz
           		 CLRF	PWMH
        		 CLRF	PWM			
				 CALL	SHIM	
				 CALL	DT11

                 BTFSS PORTA,4;              
                 GOTO   REG4_1
                 RETURN

REG4_1

							  
				 MOVF	SIST3,0
				 ADDLW	.30
				 MOVWF	TEMP_RED

REG4_2
                 BTFSC PORTA,4;   =0 
				 RETURN			
			 	 MOVF	SIST3,0
				 SUBWF	TEMP_RED,0	
                 BTFSS   STATUS,Z
                 GOTO   REG4_2
	   			 BSF     Frab
                 BSF     F_RED
				 MOVF	 SIST4,0		
				 ADDLW	 .10
                 MOVWF   ZAD_RED
                 BSF     DBB,4
                 MOVF    DBB,0
                 MOVWF   PORTB
REG4_3
                 BTFSS PORTA,4;   =0 
				 GOTO   REG4_3

                 RETURN
;------------------------------------ 
REG3                 
                 BSF     DBB,2
                 BSF     DBB,3;                 
                 MOVF    DBB,0
                 MOVWF   PORTB
REG1_3

                 BTFSC Favr                
                 GOTO   REG1_5

		         BTFSC     F_RED;
 		 		 RETURN 

                 MOVF    SVDH,1
                 BTFSS   STATUS,2
                 GOTO    REG1_4
                 MOVF    SVDL,1
                 BTFSS   STATUS,2
                 GOTO    REG1_4
                 
REG1_5 
                 BCF     DBB,4
                 MOVF    DBB,0
                 MOVWF   PORTB
                 RETURN
REG1_4
                 BTFSC   PR_ZAD_R
              	 RETURN

                 BSF     DBB,4
                 MOVF    DBB,0
                 MOVWF   PORTB
                 RETURN
                
REG5               
                 BCF     DBB,4
                 BSF     DBB,3;
                 BCF     DBB,2
                 MOVF    DBB,0
                 MOVWF   PORTB
                 BTFSS   PR_5 
                 GOTO    REG3             
                 RETURN                  
                 
                 
                 
                 
                  
  	
IND

			MOVF	ZAD_RED,0
			SUBWF	SIST4,0
			BTFSC	STATUS,Z
			BCF		F_RED




 		BTFSS	F_RED        	
    	RETURN	
    	

IND_RED
 
;------------------------------------------    	
IND_RED2
				 BTFSC	DBB,5
				 GOTO	IND_RED3

                 MOVLW   0X05;   ZAD=0.5 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
IND_RED5

                 BSF     DBB,2
                 BSF     DBB,3;                 
                 MOVF    DBB,0
                 MOVWF   PORTB
                 BTFSC   PR_ZAD1
                 GOTO    IND_RED5
				 BSF	 DBB,5
                 MOVF    DBB,0
                 MOVWF   PORTB

 			   	 RETURN
;-------------------------------------------------------------
IND_RED3

                 MOVLW   0X05;   ZAD=0.5 SEK
                 MOVWF   TEMP1;
                 BSF     PR_ZAD1
IND_RED6
 


                 BSF     DBB,3;
                 BCF     DBB,2
                 MOVF    DBB,0
                 MOVWF   PORTB
                 BTFSC   PR_ZAD1
                 GOTO    IND_RED6
				 BCF	 DBB,5
                 MOVF    DBB,0
                 MOVWF   PORTB

 			   	 RETURN

;--------------------------
SHIM                  
                

 
 
                 MOVF    PWM,0
                 MOVWF   NLR
                 
                 MOVF    PWMH,0          
                 MOVWF   NHR
                 



				 MOVF	NHR, 0;		
				 SUBLW	0X03
				 MOVWF	R1
		
				 MOVF	NLR, 0	;	
				 SUBLW	0X7F
				 MOVWF	R2
				 BTFSS	STATUS,C
				 DECF	R1,1


		         BTFSS   R1,7;
				 BCF	 DBB,6
		         BTFSS   R1,7;   SL1,7=0    
				 GOTO	SA31    ;     SDVH  SDVH1



                 MOVLW   0X03
                 MOVWF   NHR
                 MOVLW   0X7F
                 MOVWF   NLR
				 BSF	 DBB,6
     
SA31


                 MOVF    DBB,0
                 MOVWF   PORTB
				
				 MOVF	NHR, 1;
				 BTFSS	STATUS,Z			
				 GOTO	SA32

				 MOVF	NLR, 0;	
				 SUBLW	0X50
				 BTFSS	STATUS,C
				 GOTO	SA32
                 MOVLW   0X00
                 MOVWF   NHR
                 MOVLW   0X50
                 MOVWF   NLR


SA32
                 BCF     STATUS,0
                 RRF     NHR,1
                 RRF     NLR,1
                 RRF     NHR,1
                 RRF     NLR,1
                 RRF     NHR,1
                 MOVF    NLR,0
                 MOVWF   CCPR1L
                 MOVF    NHR,0
                 ANDLW   B'11000000'
                 MOVWF   NHR
                 RRF     NHR,1
                 RRF     NHR,1
                 MOVF    NHR,0
                 ADDLW   B'00001100'
                 MOVWF   CCP1CON
                 RETURN
    			
OPROSKN
;-----------------------------------------     	    	
OPROSKN

;---------   --


                 BTFSC   NP1,7
                 GOTO    OPN7
                 BTFSC   NP1,6
                 GOTO    OPN6
                 BTFSC   NP1,5
                 GOTO    OPN5
                 BTFSC   NP1,4
                 GOTO    OPN4
                 BTFSC   NP1,3
                 GOTO    OPN3


                 BTFSC   NP1,2
                 GOTO    OPN2
                 BTFSC   NP1,1
                 GOTO    OPN1
                 BTFSC   NP1,0
                 GOTO    OPN0
                 GOTO    OPN20
;------------------------
OPN0
                 CLRF    NPR
                 GOTO    OPN20
;-----------------------
OPN1
                 MOVLW   .1
                 MOVWF   NPR
                 GOTO    OPN20                           
;-----------------------
OPN2
                 MOVLW   .2
                 MOVWF   NPR
                 GOTO    OPN20
;-----------------------
OPN3
                 MOVLW   .3
                 MOVWF   NPR
                 GOTO    OPN20                           
;-----------------------
OPN4
                 MOVLW   .4
                 MOVWF   NPR
                 GOTO    OPN20           
;-----------------------
OPN5
                 MOVLW   .5
                 MOVWF   NPR
                 GOTO    OPN20                           
;-----------------------
OPN6
                 MOVLW   .6
                 MOVWF   NPR
                 GOTO    OPN20
;-----------------------
OPN7
                 MOVLW   .7
                 MOVWF   NPR
                 GOTO    OPN20                           
;-----------------------
 
OPN20
 
 
                 MOVF    NPR,0
                 SUBLW   .0

                 BTFSC   STATUS,2
                 GOTO    DB0
                 MOVF    NPR,0
                 SUBLW   .1
                 BTFSC   STATUS,2
                 GOTO    DB1
                 MOVF    NPR,0
                 SUBLW   .2
                 BTFSC   STATUS,2
                 GOTO    DB2
                 MOVF    NPR,0
                 SUBLW   .3
                 BTFSC   STATUS,2
                 GOTO    DB3
                 MOVF    NPR,0
                 SUBLW   .4
                 BTFSC   STATUS,2
                 GOTO    DB4
                 MOVF    NPR,0
                 SUBLW   .5
                 BTFSC   STATUS,2
                 GOTO    DB5
                 MOVF    NPR,0
                 SUBLW   .6
                 BTFSC   STATUS,2
                 GOTO    DB6
                 MOVF    NPR,0
                 SUBLW   .7
                 BTFSC   STATUS,2
                 GOTO    DB7
                 RETURN       
 
;--------- DB-0 ----------------------------
;---   -------------
;-- --   8888-888---------------------
DB0          


                 CLRWDT
				 MOVF	TIP_DV,0
                 MOVWF   R8
                 MOVLW   .10
                 MOVWF   R4      
                 MOVF    VDH,0
                 MOVWF   TEKH
                 MOVF    VDL,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    COI,0
                 MOVWF   R7
                 MOVF    DEI,0
                 MOVWF   R6
                 MOVF    EDI,0
                 MOVWF   R5
                 MOVF    IDH,0
                 MOVWF   TEKH
                 MOVF    IDL,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    COI,0
                 MOVWF   R3
                 MOVF    DEI,0
                 MOVWF   R2
                 MOVF    EDI,0

				BTFSC	PORTB,1
				MOVLW	.1
				BTFSS	PORTB,1
				MOVLW	.2
                 MOVWF   R1
                 RETURN
 ;--------- DB-1 ------------------------------------
;---    ----- 
;--        --   1888#8888 ---------------------
DB1 

	


                 
                 MOVF    VDH,0
                 MOVWF   TEKH
                 MOVF    VDL,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    DCOI,0
                 MOVWF   R8
                 MOVF    COI,0
                 MOVWF   R7
                 MOVF    DEI,0
                 MOVWF   R6
                 MOVF    EDI,0
                 MOVWF   R5                
                 MOVF    SVDH,0
                 MOVWF   TEKH
                 MOVF    SVDL,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    DCOI,0
                 MOVWF   R4              
                 MOVF    COI,0
                 MOVWF   R3
                 MOVF    DEI,0
                 MOVWF   R2
                 MOVF    EDI,0
                 MOVWF   R1
                 RETURN
;--------- DB-2 ---------------------------------------
 ;---    -----
;-- --   28888888-------------------------------- 
DB2 
                
                 MOVF    IDH3,0
                 MOVWF   TEKH
                 MOVF    IDL3,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    DCOI,0
                 MOVWF   R8
                 MOVF    COI,0
                 MOVWF   R7
                 MOVF    DEI,0
                 MOVWF   R6
                 MOVF    EDI,0
                 MOVWF   R5                
                 MOVF    SPWMH,0
                 MOVWF   TEKH
                 MOVF    SPWML,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    DCOI,0
                 MOVWF   R4              
                 MOVF    COI,0
                 MOVWF   R3
                 MOVF    DEI,0
                 MOVWF   R2
                 MOVF    EDI,0
                 MOVWF   R1
                 RETURN
 ;--------- DB-3--------------------------           
 ;------  C --
  ;-- --   8888#8888------------------           
DB3   


           		MOVF    DIFH,0
                MOVWF   TEKH
                MOVF    DIF,0
                MOVWF   TEKL
                CALL    BINDES11           
                MOVF    DCOI,0
                MOVWF   R8
                MOVF    COI,0
                MOVWF   R7
                MOVF    DEI,0
                MOVWF   R6      
                MOVF    EDI,0
                MOVWF   R5    
                
                MOVF    E1H,0
                MOVWF   TEKH
                MOVF    E1,0
                MOVWF   TEKL
                CALL    BINDES11
             	MOVLW   .15
                BTFSC	ZNAK
                MOVLW   .10
                MOVWF   R4   
                MOVF    COI,0
                MOVWF   R3
                MOVF    DEI,0
                MOVWF   R2
                MOVF    EDI,0
                MOVWF   R1      
                RETURN
                 RETURN

;--------- DB-4--------------------------           
 ;------  C --
 ;----------  --------------
 ;-- --   8888#8888------------------           
DB4

                 MOVF   TIP_DV,0                 
                 MOVWF   TEKL                 
                 CALL    BINDES10
                 MOVF    DEI,0
                 MOVWF   R8               
                 MOVF    EDI,0
                 MOVWF   R7
                 MOVLW   .10
                 MOVWF   R6    
                 MOVWF   R5
                 MOVF    N_TIPH,0
                 MOVWF   TEKH
                 MOVF    N_TIPL,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    DCOI,0
                 MOVWF   R4
                 MOVF    COI,0
                 MOVWF   R3
                 MOVF    DEI,0
                 MOVWF   R2
                 MOVF    EDI,0
                 MOVWF   R1
                 RETURN       
 
 ;--------- DB-5--------------------------           
 ;------Feer +PWM------
 ;-- --   8888-8888------------------           
DB5            

                 MOVF   Rkd,0                 
                 MOVWF   TEKL                 
                 CALL    BINDES10
                 MOVF    DEI,0
                 MOVWF   R8               
                 MOVF    EDI,0
                 MOVWF   R7
                 MOVLW   .10
                 MOVWF   R6    
                 MOVF   Rkp,0                 
                 MOVWF   TEKL                 
                 CALL    BINDES10
                 MOVF    DEI,0
                 MOVWF   R5               
                 MOVF    EDI,0
                 MOVWF   R4
              
                 MOVLW   .10
                 MOVWF   R3
                  
                 MOVF   Rki,0                 
                 MOVWF   TEKL                 
                 CALL    BINDES10
                 MOVF    DEI,0
                 MOVWF   R2                 
                 MOVF    EDI,0
                 MOVWF   R1
                 RETURN    



 ;--------- DB-6--------------------------           
;-- --   4--88888------------------           
DB6 

                 MOVF   T_per,0                 
                 MOVWF   TEKL                 
                 CALL    BINDES10
                 MOVF    COI,0
                 MOVWF   R8  
                 MOVF    DEI,0
                 MOVWF   R7               
                 MOVF    EDI,0
                 MOVWF   R6

                 MOVLW   .10
                 MOVWF   R5

                 MOVF    NHM,0
                 MOVWF   TEKH
                 MOVF    NLM,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    DCOI,0
                 MOVWF   R4              
                 MOVF    COI,0
                 MOVWF   R3
                 MOVF    DEI,0
                 MOVWF   R2
                 MOVF    EDI,0
                 MOVWF   R1
                 RETURN


;--------- DB-7--------------------------           
;------   --------
 ;-- --   7---8888------------------           
DB7         
           
                 MOVF    Rko,0
                 MOVWF   TEKL 
                 CALL    BINDES10
                 MOVF    EDI,0
                 MOVWF   R7   
       
 
                 MOVLW   .10
                 MOVWF   R8
                 MOVWF   R6
 
                 MOVF    PWMH ,0
                 MOVWF   TEKH
                 MOVF    PWM ,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    CCOI,0
                 MOVWF   R5    
                 MOVF    DCOI,0
                 MOVWF   R4              
                 MOVF    COI,0
                 MOVWF   R3
                 MOVF    DEI,0
                 MOVWF   R2
                 MOVF    EDI,0
                 MOVWF   R1      
                 RETURN
                 
;--------- DB-10 ----------------------------
;---   -------------
;-- --   8888-888---------------------
DB10          

                 CLRWDT
				 MOVLW	.1
			;	 BTFSS	PR_M1	
			;	 MOVLW	.2
                 MOVWF   R8
                 MOVLW   .10
                 MOVWF   R4      
                 MOVF    VDH,0
                 MOVWF   TEKH
                 MOVF    VDL,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    COI,0
                 MOVWF   R7
                 MOVF    DEI,0
                 MOVWF   R6
                 MOVF    EDI,0
                 MOVWF   R5
                 MOVF    IDH,0
                 MOVWF   TEKH
                 MOVF    IDL,0
                 MOVWF   TEKL
                 CALL    BINDES11
                 MOVF    COI,0
                 MOVWF   R3
                 MOVF    DEI,0
                 MOVWF   R2
                 MOVF    EDI,0
                 MOVWF   R1
                 RETURN
;****************************************************************
;
;               VIVOD
;
;****************************************************************
VIVOD
				 INCF	SL4,1
				 BTFSS	STATUS,Z
				 RETURN

				 INCF	SL5,1
				 MOVF	SL5,0
				 SUBLW	.30
				 BTFSS	STATUS,Z
				 RETURN




VIVOD1

;-----------------------------------
        		 CALL    OPROSKN
;-----------------------------------				
			     CLRF	SL5 
                 BCF SSPCON,5
                 BSF DBC,6
                 MOVF    DBC,0
                 MOVWF   PORTC           
                 BCF DBC,6
                 MOVF    DBC,0
                 MOVWF   PORTC
                 BCF DBC,3
                 MOVF    DBC,0
                 MOVWF   PORTC
                 BSF DBC,3
                 MOVF    DBC,0
                 MOVWF   PORTC
                 BSF DBC,6
                 MOVF    DBC,0
                 MOVWF   PORTC
                 BSF SSPCON,5            
                 CLRWDT
 
;-----------1----------

                 MOVLW   0X0C
                 MOVWF   RV
                 CALL    VIV1

                 MOVF    SSPBUF,0
                 MOVWF   NP1
                 COMF    NP1,1

                 MOVLW   0X01
                 CALL    VIV2

                 MOVF    SSPBUF,0
                 MOVWF   TEMPA
                 COMF    TEMPA,1
				 MOVF	 TEMPA,0
				 ANDLW	 0X0F
   ;              MOVWF   Rkp
				 SWAPF	 TEMPA,0
				 
				 ANDLW	 0X0F
    ;             MOVWF   Rkd
 		
;----------------------
 
                 MOVLW   0X09
                 MOVWF   RV                      
                 CALL    VIV1

                 MOVF    SSPBUF,0
                 MOVWF   TEMPA
                 COMF    TEMPA,1
				 MOVF	 TEMPA,0
				 ANDLW	 0X0F
      ;           MOVWF   Rko
				 SWAPF	 TEMPA,0	
				 ANDLW	 0X0F
     ;            MOVWF   Rki

                 MOVLW   0XFF
                 CALL    VIV2

                 MOVF    SSPBUF,0
                 MOVWF   TEMPA
                 COMF    TEMPA,1
				 MOVF	 TEMPA,0
				 ANDLW	 0X0F
    ;             MOVWF   TIP_DV
				 MOVF	 TEMPA,0	
				 ANDLW	 0XF0
       ;          MOVWF   T_per
 ;----------------------
        
                 MOVLW   0X0A
                 MOVWF   RV      
                 CALL    VIV1
                 MOVLW   0X08
                 CALL    VIV2
;----------------------
 
                 MOVLW   0X0B
                 MOVWF   RV              
                 CALL    VIV1
                 MOVLW   0X07
                 CALL    VIV2
;----------------------

                 MOVLW   0X0F
                 MOVWF   RV              
                 CALL    VIV1
                 CLRW
                 CALL    VIV2
 ;---------------------
                 MOVLW   0X01
                 MOVWF   RV      
                 CALL    VIV1
                 MOVF    R1,0
                 CALL    VIV2
;--------------------
 
                 MOVLW   0X02
                 MOVWF   RV
                 CALL    VIV1
                 MOVF    R2,0
                 CALL    VIV2
 ;--------------------
 
                 MOVLW   0X03
                 MOVWF   RV              
                 CALL    VIV1
                 MOVF    R3,0
                 CALL    VIV2
;-------------------
                 MOVLW   0X04
                 MOVWF   RV              
                 CALL    VIV1
                 MOVF    R4,0
                 CALL    VIV2
;-------------------            
;---------------------
        
                 MOVLW   0X05
                 MOVWF   RV      
                 CALL    VIV1
                 MOVF    R5,0
                 MOVWF   RV
                 CALL    VIV2
;--------------------
                  
                 MOVLW   0X06
                 MOVWF   RV              
                 CALL    VIV1
                 MOVF    R6,0
                 CALL    VIV2
 ;--------------------
 
                 MOVLW   0X07
                 MOVWF   RV              
                 CALL    VIV1
                 MOVF    R7,0
                 CALL    VIV2
;-------------------
 
                 MOVLW   0X08
                 MOVWF   RV              
                 CALL    VIV1
                 MOVF    R8,0
                 CALL    VIV2
;-------------------
                 RETURN          

VIV1
                 BCF     DBC,1
                 MOVF    DBC,0
                 MOVWF   PORTC
                 MOVF    RV,0
                 MOVWF   SSPBUF
VSPI1
                 BTFSS   PIR1,3
                 GOTO    VSPI1
                 BCF     PIR1,3
                 RETURN          
VIV2
                 MOVWF   SSPBUF
VSPI2
                 BTFSS   PIR1,3
                 GOTO    VSPI2
                 BCF     PIR1,3
;-------------------
                 BSF             DBC,1
                 MOVF    DBC,0
                 MOVWF   PORTC
                 RETURN              

    
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
YST
 
;************16-2/10**************************************************************************
BINDES10
                 CLRF    TEKH
BINDES11
                 MOVLW   .16
                 MOVWF   COU
BIDE
                 BCF     STATUS,0
                 RLF             TEKL,1
                 RLF             TEKH,1
                 RLF             EDA,1
                 RLF             DEA,1
                 RLF             COA,1
                 DECFSZ  COU,1
                 GOTO    RASDES          
                 GOTO    MESTO
RASDES 
                 MOVLW   EDA
                 MOVWF   FSR
                 CALL    BCD
                 MOVLW   DEA
                 MOVWF   FSR
                 CALL    BCD     
                 MOVLW   COA
                 MOVWF   FSR
                 CALL    BCD             
                 GOTO    BIDE    

BCD
                 MOVLW   .3
                 ADDWF   0,0
                 MOVWF   TEMPA
                 BTFSC   TEMPA,3
                 MOVWF   0               
                 MOVLW   30
                 ADDWF   0,0
                 MOVWF   TEMPA
                 BTFSC   TEMPA,7
                 MOVWF   0
                 RETURN
;--------------------------------------------
MESTO
                 MOVLW   0X0F
                 ANDWF   COA,0
                 MOVWF   CCOI                                 
                 MOVLW   0XF0                            
                 ANDWF   DEA,0
                 MOVWF   DCOI
                 SWAPF   DCOI,1
                 MOVLW   0X0F
                 ANDWF   DEA,0
                 MOVWF   COI
                 MOVLW   0XF0                            
                 ANDWF   EDA,0
                 MOVWF   DEI
                 SWAPF   DEI,1
                 MOVLW   0X0F
                 ANDWF   EDA,0
                 MOVWF   EDI
                 CLRF    EDA
                 CLRF    DEA
                 CLRF    COA
                RETURN
;------------------------------------------------
        
        END                       ; directive 'end of program'

